note
	description: "counting application root class"
	date: "$Date$"
	revision: "$Revision$"

class
	TEST_UTIL

inherit
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application. 
		do
			add_boolean_case (agent t1)
			add_boolean_case (agent t2)
			add_boolean_case (agent t3)

			show_browser
			run_es_test
		end


feature
	t1: BOOLEAN
		local
			f1: FUNCTION[INTEGER, INTEGER, INTEGER]
			f2: FUNCTION[INTEGER, INTEGER]
			f3: FUNCTION[INTEGER, INTEGER]
			f4: FUNCTION[INTEGER]
		do
			comment("t1: test partial application")
			f1 := agent subtract(?, ?)
			f2 := agent subtract(3, ?)
			f3 := agent subtract(?, 4)
			f4 := agent subtract(3, 4)

			Result := f1(7, 2) = 5
			check Result end

			Result := f2(4) = -1
			check Result end

			Result := f3(4) = 0
			check Result end

			Result := f4.item ([]) = -1
		end

	t2: BOOLEAN
		local
			u: UTIL
			a: ARRAY[INTEGER]
		do
			comment("t2: test counting quantifier with named function")
			create u.make
			a := <<1, 2, 3, 4, 5, 6>>
			Result := u.counting (a, agent is_even (?))= 3
			check Result end

			Result := u.counting (a, agent is_even)= 3
		end

	t3: BOOLEAN
		local
			u: UTIL
			a: ARRAY[INTEGER]
		do
			comment("t3: test counting quantifier with anonymous function")
			create u.make
			a := <<1, 2, 3, 4, 5, 6>>
			Result := u.counting (
							a,
							agent (i: INTEGER): BOOLEAN
								do
									Result := i \\ 2 = 0
								end
							) = 3
		end

feature -- Heler Queries

	is_even(i: INTEGER): BOOLEAN
		do
			Result := i \\ 2 = 0
		end

	subtract(x: INTEGER; y: INTEGER): INTEGER
		do
			Result := x - y
		end

end
